/* captcha */
(function ( $ ) {
	$.fn.PuzzleCAPTCHA = function( options ) {

		var sets = $.extend({
			imageURL:'./ressources/img/captcha_logo.jpg',
			height: 103,
			width: 300,
			columns: 4,
			rows: 2,
			targetInput: ".hiddencaptcha",
			targetVal: "ok",
			targetButton: "#saveForm"
		}, options );

		$(sets.targetButton).prop("disabled",true);
		var nbClick = 0;
		var tmpObj=this;
		tmpObj.addClass("puzzleCAPTCHA");
		tmpObj.append('<div class="pcBox"><div class="pcBoxBG"><img src="'+sets.imageURL+'" style="width:'+sets.width+';height:'+sets.height+';"></div></div> <div class="pcAnswer"></div>');

		tmpObj.find(".pcBoxBG img").load(function(){
			tmpImg=$(this);

			if(sets.width == 'auto'){
				tmpW=tmpImg.width();
				tmpH=tmpImg.height();
			}else{
				tmpW=sets.width;
				tmpH=sets.height;
			}
			itemW = Math.round(tmpW/sets.columns);
			itemH = Math.round(tmpH/sets.rows);

			tmpObj.find(".pcAnswer").width(itemW).height(itemH).append( tmpImg.clone() ).css({'margin-top':tmpH/2-itemH/2});

			tmpObj.find(".pcBox").width(tmpObj.find(".pcBox").width()-1);
			tmpObj.find(".pcBox").height(tmpObj.find(".pcBox").height()-1);

			tmpAnswer=Math.floor(Math.random() * sets.columns * sets.rows);

			var x,y,tmpItem,i;

			tmpItem = $(document.createElement("div"));
			tmpItem.addClass("pcBoxItem");

			i=0;

			for(x=0;x<sets.columns;x++){
				for(y=0;y<sets.rows;y++){
					tmpLeft=itemW*x;
					tmpTop=itemH*y;
					if(i==tmpAnswer){
						answerLeft=tmpLeft;
						answerTop=tmpTop;
					}

					_item=tmpItem.clone().attr("data-val",i).css({
						width:itemW,
						height:itemH,
						left:tmpLeft,
						top:tmpTop
					}).append(tmpImg.clone());
					tmpObj.find(".pcBox").append(_item);

					i++;
				}
			}
			tmpObj.find(".pcBoxItem img, .pcAnswer img").css({'margin-left':answerLeft*-1,'margin-top':answerTop*-1});

			tmpObj.find(".pcBoxItem").click(function(){
				if(nbClick<4){
					if($(this).data("val")==tmpAnswer){
						tmpObj.find(".pcBoxItem").fadeOut(300);
						if(sets.targetInput!=null){
							$(sets.targetInput).val(sets.targetVal);
						}
						if(sets.targetButton!=null){
							
							$('[name="last"]').html($('[name="last"]').html()+"<input type='button' id='saveForm' class='button' name='submit' value='Submit'  onClick='validation1();'></input><div style='float:right;color:green;font-weight:bold' id='result'></div><div style='float:right;color:red;font-weight:bold' id='error'></div>");
						}
					}
					else{
						nbClick=nbClick+1;
					}
				}else{
					$('#result').text("MAX ESSAI");
				}
			});

		});

		return this;

	};

}( jQuery ));
